#author: Samuel Revolinski
#Date: 08/19/2019
#description: This file is to remove degs that do not have GO term

#loading in DEGs
DEG = read.table("DEGs for FUNCE.txt",sep = "\t",stringsAsFactors = F)

DEG = DEG[,1:2]
#DEG = DEG[-1,]
names(DEG)[1]="geneID"
names(DEG)[2]="module"

#load func-E input 
GOs = read.csv("FUNC-E_input.csv", stringsAsFactors = F)
GOs = GOs[,-1]


#removing exon alternative splicing notation as go 
#removing the dots so I can merge the files
i = 1
noDot = list()
while(i<nrow(GOs)+1){
  nuName = strsplit(GOs[i,1],"\\.")[[1]][1]
  noDot[i]=nuName
  i = i + 1
}

#replace column 1 in goes with no exon version
GOs[,1] = unlist(noDot)



#now converting Go names to have v2 instead of V1
i = 1
ls = list()
while(i<nrow(DEG)+1){
  substr(DEG[i,1], 11, 11) = "1" 
  i = i + 1
}


#match finds first location of v1 in v2 and returns NA if nothing
#will use this to get NA's where NA was present for Go term from 
#annotation

#v1 is DEG, V2 is GO list

v1 = DEG$geneID
v2 = GOs$geneID

noGO = match(v1,v2)
noGO_filter = is.na(noGO)

#filtering DEGs

filteredDEG = DEG[!noGO_filter,]
filteredDEG$geneID[1:20]

DEG$geneID[1:20]


#testing merge to make sure it is still good
m = merge(filteredDEG,GOs,by="geneID")


Write(filteredDEG,file="filteredDEG.txt",sep="\t")
write.table(filteredDEG,file="filteredDEG.txt",sep="\t")



#getting uniques from GO list
un = unique(GOs$geneID)
tab = data.frame(un)

write.table(tab,file="uniqueGENE.txt",sep="\t")


########## creating and writing the FUNC-E input files ########## 

###creating terms list from full list with all go terms. 

#getting need columns from GOs full list
TermList = GOs[,2:3]
TermList = data.frame(GO=as.character(rep("GO",nrow(TermList))),TermList)
TermList$GO = as.character(TermList$GO)

#removing repeated observations
TermList = unique(TermList)
write.table(TermList,"TermList.txt",sep = "\t")

### making query list 

queryList = unique(m[,1:2])

write.table(queryList,file = "queryList.txt",sep = "\t")

### term mapping list

mapList = unique(GOs[,1:2])
write.table(mapList,file = "mapList.txt",sep = "\t")


